--
-- RUL
-- Class for Claas RUL
--
-- @author  JACK (ICQ brauchst du nicht )
-- @date  21/04/09

RUL = {};

function RUL.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function RUL:load(xmlFile)
	self.setRundumleuchte = SpecializationUtil.callSpecializationsFunction("setRundumleuchte");
	local i = 0;
	self.rundumleuchten = {};
	self.rundumleuchtenAn = false;
	while true do
		local rul = {};
		local objname = string.format("vehicle.rundumleuchten.rundumleuchte(%d)",i);
		local rotnode = getXMLString(xmlFile, objname .. "#rotNode");
		if rotnode == nil then 
			break;
		end;
		rul = {};
		rul.rotNode = Utils.indexToObject(self.components, rotnode);
		rul.light = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#light"));
		if(rul.rotNode == nil or rul.light == nil) then
			print("Error: Index ("..rotnode..") zur Rundumleuchte nicht gefunden");
		else
			rul.speed = Utils.getNoNil(getXMLInt(xmlFile,  objname .. "#rotSpeed"), 1)/1000;
			rul.source = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#lightsource"));
			if (rul.source == nil) then
				rul.emit = false;
			else
				rul.emit = Utils.getNoNil(getXMLBool(xmlFile, objname .. "#emitLight"), true);
				if not rul.emit then
					setVisibility(rul.source, false);
				end;
			end;
			table.insert(self.rundumleuchten, rul);
		end;
		i=i+1;
	end;
	self.rundumleuchtenAnz = table.getn(self.rundumleuchten);
    self.keys = {};
    local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
        local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
           break;
        end;
        self.keys[inputName] = Input[inputKey];
--        print("Keys: " .. inputName .. " = " .. inputKey .. " = " .. Input[inputKey] .. " : " .. self.keys[inputName]);
        i = i+1;
    end;
	
end;

function RUL:readStream(streamId, connection)
	self:setRundumleuchte(streamReadBool(streamId), true);
end;

function RUL:writeStream(streamId, connection)
	streamWriteBool(streamId, self.rundumleuchtenAn);
end;

function RUL:keyEvent(unicode, sym, modifier, isDown)
end;

function RUL:update(dt)
	if self.rundumleuchtenAnz > 0 and self:getIsActive() then
		if self.isEntered and InputBinding.hasEvent(InputBinding.HRUNDUMLEUCHTE) then
			self:setRundumleuchte(not self.rundumleuchtenAn);
		end;
		if self.rundumleuchtenAn then
			for i=1, self.rundumleuchtenAnz do
				rotate(self.rundumleuchten[i].rotNode, 0, dt*self.rundumleuchten[i].speed, 0);
			end;
		end;
	end;
end;

function RUL:draw()
	
end;

function RUL:mouseEvent(posX, posY, isDown, isUp, button)
end;

function RUL:onEnter()
end;

function RUL:delete()

end;

function RUL:onLeave() 
	self:setRundumleuchte(false);
end;

function key_convert(key)
    if key ~= nil then 
	    local keyname = "";
	    if key > 32 and key < 123 then
	    	keyname = string.upper(string.char(key));
	    elseif key > 255 and key < 266 then
	    	keyname = "NUM "..string.char(key-208);
	    else 
	    	keyname = "";
	    end;
	    return(keyname);
	  end;
end;

function RUL:setRundumleuchte(state, noSendEvent)
	self.rundumleuchtenAn = state;
	for i=1, self.rundumleuchtenAnz do
		setVisibility(self.rundumleuchten[i].light, self.rundumleuchtenAn);
	end;
	if noSendEvent ~= true then
		RULEvent.sendEvent(self, RULEventType.rundumleuchte, self.rundumleuchtenAn);
	end;
end;