RULEvent = {};
RULEvent_mt = Class(RULEvent, Event);

InitEventClass(RULEvent, "RULEvent");

RULEventType = {
	rundumleuchte = 1,
}

function RULEvent:emptyNew()
    local self = Event:new(RULEvent_mt);
    self.className="RULEvent";
    return self;
end;

function RULEvent:new(object, eventType, data)
    local self = RULEvent:emptyNew()
    self.object = object;
	self.eventType = eventType;
	self.data = data;
    return self;
end;

function RULEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.object = networkGetObject(id);
	self.eventType = streamReadUInt8(streamId);
	if self.eventType == RULEventType.rundumleuchte then
		self.data = streamReadBool(streamId);
		self.object:setRundumleuchte(self.data, true);
	end;
    if not connection:getIsServer() then
        g_server:broadcastEvent(RULEvent:new(self.object, self.eventType, self.data), nil, connection, self.object);
    end;
end;

function RULEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteUInt8(streamId, self.eventType);
	streamWriteBool(streamId, self.data);
end;

function RULEvent.sendEvent(vehicle, eventType, data)
	if g_server ~= nil then
		g_server:broadcastEvent(RULEvent:new(vehicle, eventType, data), nil, nil, vehicle);
	else
		g_client:getServerConnection():sendEvent(RULEvent:new(vehicle, eventType, data));
	end;
end;

